// Written by TeTeT for Nimitz

[] spawn {

	// private _lso = nimitz getVariable "JDG_carrier_deck_12";

	// private _camPos = _lso modelToWorld (_lso selectionPosition "pip0_pos");

	private _camPos = (nimitz getVariable "JDG_carrier_nimspots") modelToWorld ((nimitz getVariable "JDG_carrier_nimspots") selectionPosition "WireCenter");
	_camPos set [2, 17.6];

	// watch 2km distance at 9 degrees angle
	private _camTarget = _camPos getPos [2000, getDir nimitz + 171];
	// 250 meter is arbitrary and most likely wrong
	_camTarget set [2, 250];
	private _cam = "camera" camCreate _camPos;
	_cam camSetTarget _camTarget;
	_cam camSetFov 0.2;
	_cam cameraEffect ["internal", "back", "rendertarget0"];
	_cam camCommit 1;
	nimitz setVariable ["ttt_nimitz_lso_cam", _cam, true];

	if (sunOrMoon < 0.5) then {
		"rendertarget0" setPiPEffect [1];
	} else {
		"rendertarget0" setPiPEffect [0];
	};
	c12 = nimitz getVariable "JDG_carrier_deck_12";
	c12 setObjectTextureGlobal [0, "#(rgb,1024,1024,1)ui(ttt_lso_camera,ttt_lso_camera)"];
	c12 setObjectTextureGlobal [1, "jdg_carrier\data\joe_lso_layover_ca.paa"];
};

// update date and time
[] spawn {
	waitUntil {not isNull (uiNamespace getVariable ["ttt_lso_camera_dsp", displayNull])};
	private _dsp = uiNamespace getVariable ["ttt_lso_camera_dsp", displayNull];

	// when the sun is down, light grey text, otherwise dark grey
	if (sunOrMoon < 0.5) then {
		{
			(_dsp displayCtrl _x) ctrlSetTextColor  [0.9, 0.9, 0.9, 1];
		} forEach [1000, 1100, 1200, 1300, 1400, 1500, 1600];
	};

	while {alive player} do {
		private _now = date;
		private _date = format ["%1-%2-%3", [(_now # 0) mod 100, 2] call CBA_fnc_formatNumber, 
		                                    [_now # 1, 2] call CBA_fnc_formatNumber, 
		                                    [_now # 2, 2] call CBA_fnc_formatNumber];
		(_dsp displayCtrl 1000) ctrlSetText _date;

		private _time = [dayTime, "HH:MM:SS"] call BIS_fnc_timeToString;
		(_dsp displayCtrl 1100) ctrlSetText _time;

		if (alive f18 and f18 distance nimitz < 1000) then {
			// speed in knots
			private _speed = speed f18 * 0.539957;
			(_dsp displayCtrl 1400) ctrlSetText ([_speed, 4, 0] call CBA_fnc_formatNumber);

			// distance in feet
			private _distance = (f18 distance nimitz) * 3.28084;
			(_dsp displayCtrl 1500) ctrlSetText ([_distance, 5, 0] call CBA_fnc_formatNumber);

			// vertical speed rate in feet
			private _rate = (velocity f18 # 2) * 3.28084;
			(_dsp displayCtrl 1600) ctrlSetText([_rate, 2, 0] call CBA_fnc_formatNumber);
		} else {
			// speed in knots
			private _speed = 0;
			(_dsp displayCtrl 1400) ctrlSetText ([_speed, 4, 0] call CBA_fnc_formatNumber);

			// distance in feet
			private _distance = 0;
			(_dsp displayCtrl 1500) ctrlSetText ([_distance, 5, 0] call CBA_fnc_formatNumber);

			// vertical speed rate in feet
			private _rate = 0;
			(_dsp displayCtrl 1600) ctrlSetText([_rate, 2, 0] call CBA_fnc_formatNumber);
		};
		// systemChat format["Setting time to %1 on %2", _time, uiNamespace getVariable "ttt_lso_camera_dsp"];
		displayUpdate (uiNamespace getVariable "ttt_lso_camera_dsp");

		sleep 0.5;
	};
};

f18 addEventHandler ["HandleDamage", {
	params ["_unit", "_source", "_damage", "_instigator"];
	systemChat format ["%1 got %2 from %3", _unit, _damage, _source];
	hint format ["%1 got %2 from %3", _unit, _damage, _source];
	0;
}];

f18 addEventHandler ["LandedStopped", {
	params ["_plane", "_airportID"];
	// hint format ["%1 landed on %2", _plane, _airportID];
	[_plane] spawn {
		params ["_plane"];
		sleep 5;
		deleteVehicleCrew _plane;
		deleteVehicle _plane;
	};
}];
